Subject: Re: [POC PATCH] diff options: Introduce --interactive

From: David Aguilar <[email-masked]>
Date: Mon, 30 Mar 2009 02:04:39 -0700

On  0, Ping Yin <[email-masked]> wrote:
> The new option --interactive introduces an interactive diff mode. Now we
> can choose to see the diff for a selected file.

I just tried it out.  Very cool.
It's exactly the functionality users have asked me about.

I just sent a for-the-future patch that teaches difftool
to tell difftool-helper that it shouldn't prompt when
you're using --interactive.

I noticed git-diff doesn't have a -i flag yet,
perhaps it could be the shorthand for --interactive?

(I'd have to change that for-the-future patch I just sent
 too since it also only checks for the long form...)

I like it.

> 
> This is a preparation to introduce the --tool option to launch the
> external diff tool for a selected file.

With both of our latest patches:

	git difftool --interactive <revargs>

does exactly what one would expect it to.

How are you envisioning --tool?  It'd be great if we didn't
need the perl wrapper, though something does need to set
GIT_EXTERNAL_DIFF/GIT_PAGER/etc... (that is, unless you have a
better way =))

> >> When the user types a number,  git-difftool-helper is launched to show
> >> the diff for the corresponding file.
> >
> > Cool.
> > I had two patches that I sent to the list for
> > git-difftool.perl.  If you're going to patch it then you might
> > want to base it on top of those.
> >
> When i try to code on git-difftool.perl, i find it is more appropriate to add
> the --interactive and then --tool options to git-diff itself. So here is a
> proof of concept patch based on next. What we should do next is to try to
> design a good UI.

I'll see if I can come up with any suggestions.
I liked it on the first test drive.

-- 

	David